;**********************************************************************                                                            *
;    Filename:      GRX1.asm    2021.06.14 1D2021.09.25 Bandagé@Hz200̓ǂݍݒǉ
;    File Version:  WFlJoM@0.5M-30MHzp@ǔokk  /TM1637\                                      *
; ;2021.03.01	QƁGPLL.asmi2020.08.13) ,KP6T1 		                                 05                                 *
;    Author:   jk1xkp                                                     *
;    Company:                                                         *
;     
;	gp
;	ohb		PIC16F819 iȊOɂp\j
;
;		NbN	NbN 8MHz
;**********************************************************************
;    Notes: 
;1.LCD\ʒu AQM0802 8x2
; 0  7  .  0  5  0  .  0  
;@L  S  B  _  S  5  0  H  
;2.dSTEP SW(PORTB.6)ȂAdB
;  VXO[h(0-255)ݒ肪Ȃ
;6.TC9256Pgp  Xtal 8MHz  Ref=10kHziVXOŁ@Max7992.188/800=9.9902kHz),̐ݒB
;7.sATCFid̔z͏ȗj
;		( H:[qopen  L:[q0`2.4kGRDɗƂ)
;	ohbPUeWPX	
;	()̓sԍ
;	RA7-OSC1(16)		LCD AQM0802	;I2C LCD_SDA
;	RA6-OSC2(15)		LCD AQM0802	;I2C LCD_SCL
;	RA5-MCR(14)  H;AMin VCO<40MHz  L;FMin VCO>40MHz
;	RA4(03)			AD9833_SCK
;	RA3(02)			TC9256P2_CK	
;	RA2(01)			AD98334_FSYNC 
;	RA2(01)			TC9256P_PRD
;	RA1(18)			TC9256P_CK	
;	RA0(17)      			
;		
;	RB7(13)			=TC9256P_DATA, AD98335_SDat	    
;	RB6(12)			=STEP SW	
;	RB5(11)			ENC-A	
;	RB4(10)			 ENC-B
;	RB3(09)			 (mode CW,LSB,USB)	
;	RB2(08)			 (mode CW,LSB,USB)
;	RB1(07)			BAND 1 or BAND 2	
;	RB0(06)			Encoder 4x{iLj	
;	GND	

;**********************************************************************

	list      p=16f819           ; list directive to define processor
	#include <p16F819.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _WDT_OFF & _PWRTE_ON &_INTRC_IO  

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.

	
#define		AD33CK  PORTA,4		;AD9833_SCK
#define		T56_2  	PORTA,3		;TC9256P2_CK
#define		PRD	   	PORTA,2		;TC9256P_PRD
#define		FSY	   	PORTA,2		;AD9833_FSY 
#define		T56   	PORTA,1		;TC9256P_CK

#define		P41   	PORTA,0		; MCP41010pSCK
#define		SDA   	PORTA,7		;I2C LCD_SDA
#define		SCL		PORTA,6		;I2C LCD_SCL

#define		DAT  	PORTB,7		;Data for TC9256 & 74HC595

;***** VARIABLE DEFINITIONS
VALUE		EQU	H'7A'
scn			EQU	H'7B'	;Bank0-4 
ADDR		EQU	H'7C'
pc_temp		EQU	H'7D'
w_temp		EQU 0x7E        ; variable used for context saving 
status_temp EQU 0x7F        ; variable used for context saving
;   --------------- adress 20&H  
USB0		EQU	0x20	;20hԒn! LCD2sڑ1"USB"\f[^[
USB1		EQU	0x21	;21hԒn! LCD2sڑ2"USB"\f[^[
USB2		EQU	0x22	;22hԒn! LCD2sڑ3"USB"\f[^[
plk			EQU	0x23	;23hԒnif PLL-Lock, then  plk=uLv=04ch, else uUv=055h
Encx4		EQU	0x24	;if Encx4,0=L, then Encoder non-click4{@ 	
SG			EQU	0x25	;NsteptONɂāASG.0=1 ,SGN	;SGg=3.5MH`0g
Snr0		EQU	0x26	;  Snr =Nr -H'11D6'	;NNr=H'1308
Snr1		EQU	0x27	;  Snr =Nr -H'11D6'	;NNr=H'1308
	;VS			EQU	0x28	; S in case step Hz  /V in case AF Volume
mV			EQU	0x29	; AN0dl@g\@-6.4`+6.4kHz炷B	
Fadj		EQU	0x2a	;if Fadj.3=1,plus(MCR_H) else minus. Fadj.2=400,Fadj.1=200,Fadj.0=No Adjust
		;,XO_10MHž덷 for AD98341999,511.719Hz(Freq=D'53,673,984')
							;fout(1999,511.719Hz)=Freq xMclk(10,000,000) /2^28 
Dsp9		EQU	0x2b	; step 50H 0.5k"c" or 10k"Blanc"		;;	
stROM		EQU	0x2c	;must be 0x2c/ 
vxo			EQU	0x2d	;VXO(0-200) must be 0x2d-
nr0			EQU	0x2e	;PLL  must be 0x2e-
nr1			EQU	0x2f	;PLL  must be 0x2f-
;   -------------- adress 30&H
Nband		EQU	0x30	;Ɂ@ must be 0x30-
dec0		EQU	0x31	;must be 0x31- 10ii[ꏊiPOoCgj
dec1		EQU 0x32    	
dec2		EQU	0x33		
dec3		EQU	0x34		
dec4		EQU	0x35	;10MHz
dec5		EQU	0x36	;1MHz
dec6		EQU	0x37	;100kHz
dec7		EQU	0x38	;10kHz
dec8		EQU	0x39	;1kHz
dec9		EQU	0x3A	;;0.1kHz
if0			EQU	0x3B	;IFg  IFset load
if1			EQU	0x3C
if2			EQU	0x3D	
wait_cn		EQU	0x3E		;
wait_cn2	EQU	0x3F		
;    ------------- adress 40&H
val0		EQU	0x40		; ϊliRQrbgj
val1		EQU	0x41
val2		EQU	0x42
val3		EQU	0x43
val_m		EQU	0x44; ꎞ]i[ꏊiTu[`Ŏgpj
y0			EQU	0x45	
y1			EQU	0x46
y2			EQU	0x47
y3			EQU	0x48
step0		EQU	0x49	;;ENCD̎gstep=1(50Hz) or 200(10kHz)
N			EQU	0x4A		
het			EQU	0x4B	;/	up=1; lower=2
c_skip		EQU	0x4C	;sub-counter for Skip
ct			EQU	0x4D		;Sub counter
cp			EQU	0x4E	;wait_ routin ŎgĂJE^Bėpgp
cs			EQU	0x4F	;wait_ routin ŎgĂJE^Bėpgp
;    ------------- adress 50&H		
cn			EQU	0x50		;
cf			EQU	0x51		;
old16		EQU	0x52	;;RB1,2,3,6  01001110 ̕ω Oldl
new16		EQU	0x53	;;RB1,2,3,6   ̕ω 
poi			EQU	0x54
x0			EQU	0x55	;
x1			EQU	0x56
x2			EQU	0x57
x3			EQU	0x58
x_m			EQU	0x59	; ꎞ]i[ꏊ(Tu[`Ŏgpj  
cu			EQU	H'5a'	;vxo=vxo+step  Up Carry Flag
cd			EQU	H'5b'  	;vxo=vxo-step  Down Carry Flag	
vfc			EQU	H'5c'	;intrruptuɂ@vfc.0=1
d4			EQU	H'5d'
d8			EQU	H'5e'
VCO_n		EQU	H'5f'	;;VCO name ?A/B/C/D
;    ------------- adress 60&H	
NRb06		EQU	0x60	; ;RB߰Ă̌ݒl bit.6-0(@RB.4, 5)
ORb06		EQU	0x61	;ORB߰Ă̒l
old45		EQU	H'62'	; ;RB4,5߰Ẳߋl Encoder
new45		EQU	H'63'	; ;RB4,5߰Ă̌ݒl
old1		EQU	H'64'  	;;;RB1߰Ẳߋl
new1		EQU	H'65'	;;;RB1߰Ă̌ݒl
xor45bit	EQU	H'66'  	;;RB4,5߰Ẳߋl Encoder 2bit shift
VCOport		EQU	H'67'	;port=o5/xx/xx/xx/ o4/o3/o2/o1, 0=OFF, 1=Low(ON)
p_chk		EQU	H'68'	;nr1 ω p_chk=1. if p_chk=1, then call PortChg
TCskp		EQU	H'69'	;if TCskp=0, skip TC56set, else go
Freq0		EQU	H'6a'	;AD9834 Freq0݁@(28jbit̂́@8bit
Freq1		EQU	H'6b'	;AD9834 Freq0݁@(28jbit̂́@8bit											
Freq2		EQU	H'6c'	;AD9834 Freq0݁@(28jbit̂́@8bit
Freq3		EQU	H'6d'	;AD9834 Freq0݁@(28jbit̂́@ŏ4bit											
CtbL		EQU	H'6e'  	;AD9843ݎ́@f[^@16bit Upper8bit
CtbU		EQU	H'6f'	; f[^@16bit Lower8bit
;    ------------- adress 70&H	
MsbL		EQU	H'70'	;gf[^@MSB 
MsbU		EQU	H'71'	;gf[^@MSB
LsbL		EQU	H'72'	;gf[^@LSB
LsbU		EQU	H'73'	;gf[^@LSB
Reg_Freq	EQU	H'74'	;if Reg_Freg=0, Freq0(ʏ), if Reg_Freg=1, Freq1,
Hz200		EQU	H'75'	;AD9833 ̊eohPLL@200Hź@ݒl@(1.999.5Hzł)

;**********************************************************************
	ORG     0x000             ; processor reset vector


	goto    start              ; go to beginning of program

	ORG     0x004             ; interrupt vector location
isr		;;荞ݏ-routine
i_rb0	movwf	w_temp		;W@File w_tempւ̕ۑ
		swapf	STATUS,0
		clrf	STATUS		;Bank0
		movwf	status_temp	;status@File@̕ۑ
		bcf		INTCON,GIE
	;===============
isr1	movf	PORTB,0  ;	ȉ@g	
		andlw	B'00110000'	
		movwf	new45

		call	wt40u	;40 usec҂.ݺނ̓,ݸޖh~		
		movf	PORTB,0		
		andlw	B'00110000'	;masking othrt than RB4-5
		subwf	new45,0
		btfss	STATUS,Z
		goto	isr1

	;	btfsc	new45,0	;if new45.rb4=H, then goto pop2
	;	goto	pop2
	;	goto	encd
		movf	new45,0
		subwf	old45,0
		btfsc	STATUS,Z
		goto	pop1
		movf	new45,0
		xorwf	xor45bit,1

		movlw	H'f'	;if step=10kHz \/Dsp9 "f;OFF" , always encoder=1
		subwf	Dsp9,0
		btfsc	STATUS,Z
		goto	Enc_1

		btfsc	Encx4,0
		goto	Enc_1
		goto	Enc_4
		;--------------	ȉ@Encoder x1{, x4{ ̏		́Aֈړ

issub	call	sub_v		;vxo=vxo-step0
		goto	pop
isadd	call 	add_v		;vxo=vxo+step0
		goto	pop

pop		bsf		vfc,0		;vfo change record, vfc=1
pop1	movf	PORTB,0	
		andlw	B'00110000'	
		movwf	old45
		movwf	xor45bit
		bcf		STATUS,C  ;Old45bit 2bit shift up
		rlf		xor45bit,1
		bcf		STATUS,C  ;
		rlf		xor45bit,1

pop2	swapf	status_temp,0	;status@File@̖߂
		movwf	STATUS	
		swapf	w_temp,1	;W@File@̖߂
		swapf	w_temp,0
		bcf		INTCON,0	;intcon-RBIF(tOj̃Zbg
		bsf		INTCON,GIE 		; Enable INTs.
				
		retfie
;-----------
; remaining code goes here
;--------------------
VCO_Nr1	addwf	PCL,1  		;;VCO؂ւg'@nr1_H'2100';<84.5MHz-62.8MHz=21.7MHz>
		retlw	H'15'	;if nr1<H'15', the VCO_A	for max53.76MHz(H'1500'=53.76MHz))
		retlw	H'19'	;if nr1<H'19', the VCO_B	for max64.00MHz(H'1900'=64.00MHz))
		retlw	H'1E'	;if nr1<H'1E', the VCO_C 	for max76.8Hz, else Stop 	

VCO_set	addwf	PCL,1  		;;VCOݒ;VCOport=o5/xx/xx/xx/ o4/o3/o2/o1, 0=High(OFF), 1=Low(ON)
				;Don't modfy here
		retlw	B'00000001'	;poi=0 VCO1=A at OT1=1<Low(ON)>	
		retlw	B'00000010'	;poi=1 VCO2=B at OT2=1<Low(ON)>
		retlw	B'00000100'	;poi=2 VCO3=C at OT3=1<Low(ON)>
		retlw	B'00000100'	;poi=3 VCO4=D at none

VCOname	addwf	PCL,1  		;;VCO name ?A/B/C/D@VCO_n@
				;Don't modfy here	
		retlw	H'41'	;;poi=0 VCO1=A
		retlw	H'42'	;;poi=1 VCO2=B
		retlw	H'43'	;;poi=2 VCO3=C 
		retlw	H'44'	;;poi=3	VCO4=D 	
;------------------------------------------
tablenumb	;portB dataB
		addwf	PCL,1  		;cycle3
;  	 	          pGFEDCBA  	7segment A`F       
		retlw	B'00111111'	;letter 0
		retlw	B'00000110'	;letter 1		
		retlw	B'01011011'	;letter 2         A	
		retlw	B'01001111'	;letter 3        ____
		retlw	B'01100110'	;letter 4     F	|    | B
		retlw	B'01101101'	;letter 5      	|_G__|
		retlw	B'01111101'	;letter 6     E	|    | C
		retlw	B'00100111'	;letter 7      	|____|    
		retlw	B'01111111'	;letter 8         D
		retlw	B'01100111'	;letter 9
		retlw	B'01110111'	;letter A
		retlw	B'01111100'	;letter b
		retlw	B'01011000'	;letter c
		retlw	B'01011110'	;letter d	
		retlw	B'01111001'	;letter E
		retlw	B'00000000'	;Blanc	
		sleep

;------------------------------------------
tab_dp	addwf	PCL,1  	;AhXf[^͂̂܂
		retlw	dec4	;poi=0	dec[4]	;u1v 
		retlw	dec5	;poi=1	dec[5]	;u4v 
		retlw	dec6	;poi=2	dec[6]	;u0v
		retlw	dec7	;poi=3	dec[7]	;u5v
		retlw	dec8	;poi=4	dec[8]	;u0v		
		retlw	Dsp9	;poi=5	dec[9]	;u1v Dsp9
		nop	

tab_dot	addwf	PCL,1  	;Dot́AB'10000000'
		retlw	B'00000000'	;;poi=0	dec[4]	;u1v 
		retlw	B'10000000'	;;poi=1	dec[5]	;u4v 
		retlw	B'00000000'	;;poi=2	dec[6]	;u0v
		retlw	B'00000000'	;;poi=3	dec[7]	;u5v
		retlw	B'10000000'	;;poi=4	dec[8]	;u0v		
		retlw	B'00000000'	;;poi=5	dec[9]	;u1v
		nop	

step200	;poi=(PLL Nr)/64-71  ;  ĺA200Hź@AD9833 Freq Phase//lx vxo/4̏v
		addwf	PCL,1  	;		;W=Nbanmd// 0=< Nband@<=8
		retlw	D'236'  ;poi=0
		retlw	D'233'  ;poi=1
		retlw	D'229'  ;poi=2
		retlw	D'226'  ;poi=3
		retlw	D'223'  ;poi=4
		retlw	D'220'  ;poi=5
		retlw	D'217'  ;poi=6
		retlw	D'215'  ;poi=7
		retlw	D'212'  ;poi=8
		retlw	D'209'  ;poi=9
		retlw	D'207'  ;poi=10
		retlw	D'204'  ;poi=11
		retlw	D'202'  ;poi=12
		retlw	D'199'  ;poi=13
		retlw	D'197'  ;poi=14
		retlw	D'195'  ;poi=15
		retlw	D'192'  ;poi=16
		retlw	D'190'  ;poi=17
		retlw	D'188'  ;poi=18
		retlw	D'186'  ;poi=19
		retlw	D'184'  ;poi=20
		retlw	D'182'  ;poi=21
		retlw	D'180'  ;poi=22
		retlw	D'178'  ;poi=23
		retlw	D'176'  ;poi=24
		retlw	D'174'  ;poi=25
		retlw	D'172'  ;poi=26
		retlw	D'171'  ;poi=27
		retlw	D'169'  ;poi=28
		retlw	D'167'  ;poi=29
		retlw	D'166'  ;poi=30
		retlw	D'164'  ;poi=31
		retlw	D'162'  ;poi=32
		retlw	D'161'  ;poi=33
		retlw	D'159'  ;poi=34
		retlw	D'158'  ;poi=35
		retlw	D'156'  ;poi=36
		retlw	D'155'  ;poi=37
		retlw	D'153'  ;poi=38
		retlw	D'152'  ;poi=39
		retlw	D'151'  ;poi=40
		retlw	D'149'  ;poi=41
		retlw	D'148'  ;poi=42
		retlw	D'147'  ;poi=43
		retlw	D'145'  ;poi=44
		retlw	D'144'  ;poi=45
		retlw	D'143'  ;poi=46
		retlw	D'142'  ;poi=47
		retlw	D'140'  ;poi=48
		retlw	D'139'  ;poi=49
		nop

B_data	addwf	PCL,1  	;		;W=Nbanmd// 0=< Nband@<=8
		goto	B_3.5	;Nband=0
		goto	B_7 	;Nband=1
		goto	B_10 	;Nband=2
		goto	B_14 	;Nband=3
		goto	B_18 	;Nband=4
		goto	B_21 	;Nband=5
		goto	B_24  	;Nband=6
		goto	B_28 	;Nband=7  ;܂Ł@H'0FF'255ȓ
	;========	

B_3.5 	nop  	;Nband=0	;3.5MHz;PLO=48.708MHz(3.55+45.158)MHz
		movlw	H'09'	; 	;=PLLPnm=4873=H'1309'
		movwf	nr0		;
		movlw	H'13'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		movlw	D'7'
		movwf	vxo
		return

B_7 	;Nr=PLLP=(7,050k+IF 45,158.0k) /10k x (8000/7998.0)=5222
		;;Nr=5223̎̕\gvZ(100HzP)=(Nr-1) x100 x(1- 1/(2^12) )+(VXO/2) -IF;451580=70292 
		nop  	;Nband=1	;7MHz;PLO=52.208MHz
		movlw	H'67'	; 	;=PLLPNr=5223=H'1467'
		movwf	nr0		;
		movlw	H'14'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		movlw	D'25'
		movwf	vxo
		return

B_10 	nop 	;Nband=2	;10.1MHz;PLO=55.308MHz(10.15+45.158)MHz
		movlw	H'9d'	; 	;=PLLPnm=5533=H'159d'
		movwf	nr0		;
		movlw	H'15'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		movlw	D'40'
		movwf	vxo
		return

B_14 	nop  	;Nband=3	;14MHz;PLO=59.458MHz(14.30+45.158)MHz
		movlw	H'3C'	; 	;=PLLPnm=5948=H'173c'
		movwf	nr0		;
		movlw	H'17'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		movlw	D'60'
		movwf	vxo
		return

B_18 	nop  	;Nband=4	;18.1MHz;PLO=63.258MHz(18.1+45.158)MHz
		movlw	H'b8'	; 	;=PLLPnm=6328=H'18b8'
		movwf	nr0		;
		movlw	H'18'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		movlw	D'79'
		movwf	vxo
		return

B_21 	nop  	;Nband=5	;21MHz;PLO=66.458MHz(21.3+45.158)MHz
		movlw	H'f8'	; 	;=PLLPnm=6648=H'19f8'
		movwf	nr0		;
		movlw	H'19'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		movlw	D'94'
		movwf	vxo
		return

B_24 	nop 	;Nband=6	;24.95MHz;PLO=70.108MHz(24.95+45.158)MHz
		movlw	H'65'	; 	;=PLLPnm=7013=H'1b65'
		movwf	nr0		;
		movlw	H'1b'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		movlw	D'112'
		movwf	vxo
		return

B_28 	nop  	;Nband=7	;28MHz;PLO=73.458MHz(28.3+45.158)MHz
		movlw	H'b4'	; 	;=PLLPnm=7348=H'1cb4'
		movwf	nr0		;
		movlw	H'1c'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		movlw	D'128'
		movwf	vxo
		return

	;==============
IFset	nop  		;;IF 100HzPʂŎgdata捞.
		movlw	H'bc'		;IFusb=(45,158.0kHz-6.4kHz)=451516(100Hz)=H'06 E3 bc'
		movwf	if0
		movlw	H'E3'
		movwf	if1
		movlw	H'06'
		movwf	if2 

;Z	if(24bit)if(24bit){mV(8bit)@;IFusb=(45,158.0kHz-6.4kHz) +mV(-6.4k`+6.4kHz)
		movf	mV,0				;add	x[0],y[0]
		addwf	if0,1
		movlw	1
		btfsc	STATUS,C
		addwf	if1,1
		btfsc	STATUS,C
		addwf	if2,1

		goto	Dlsb

Dlsb	movlw	H'44'	;Chara "D"
		movwf	USB0
		movlw	H'53'	;Chara "S"
		movwf	USB1
		movlw	H'42'	;Chara "B"
		movwf	USB2
		goto	D_end
D_end	return

;---------------------荞ݏuroutin------------
		;--------------	ȉ@Encoder x1{ ̏	
Enc_1	movlw	B'11100000'		;old_BA=11, new_BA=10 then 1110+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'01000000'		;old_BA=01, new_BA=00 then 0100+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub
		goto	pop1
		;--------------	ȉ@Encoder x4{ ̏
Enc_4	btfss	step0,0	;if step=200(10kHz)=B'11001000', goto Enc_1
		goto	Enc_1

		movlw	B'11100000'		;old_BA=11, new_BA=10 then 1110+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'10000000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'00010000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'01110000'		
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'11010000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub

		movlw	B'01000000'		;old_BA=01, new_BA=00 then 0100+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub

		movlw	B'00100000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub

		movlw	B'10110000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub
		goto	pop1
	;-------------------
;-----------------------------------------------------------		
add_v					;15step		
		clrf	cu	;Up Carry Flag
		movlw	D'56'
		addwf	vxo,1	;vxo= vxo+ 56
		movf	step0,0
		addwf	vxo,1	;vxo=vxo+ step0
		btfss	STATUS,C
		bcf		cu,0
		btfsc	STATUS,C
		bsf		cu,0	;vxo=vxo+step  Up Carry Flag// C bitcu.0=1
		btfsc	cu,0
		bsf		TCskp,0	; Not skip TC56set
		
		bcf		STATUS,C
		movlw	D'1'
		btfsc	cu,0	;STATUS,C łCarry̑
		addwf	nr0,1	;nr0= nr0+1
		btfss	STATUS,C
		goto	add_3
		incf	nr1,1
		bsf		p_chk,0	;if nr1 change, then p_chk,0=1

add_2	movlw	H'1E'	;nr=H'1E00' =76.80MHz 
		subwf	nr1,0		;W=nr1 +(256- H'1E' )
		movlw	H'1D'
		btfss	STATUS,C
		goto	add_3
		movwf	nr1		;@nr=H'1DFF'
		movlw	H'FF'
		movwf	nr0		 

add_3	movlw	D'56'
		btfsc	cu,0	;if cu.0=1, then Carry up,Zsv
		movlw	D'0'						
		subwf	vxo,1	;W= vxo+ (256-56)
		;goto	pop
		return
sub_v				;14step
		clrf	cd	;Down Carry Flag
		movf	step0,0
		subwf	vxo,1	;vxo= vxo+ (256-step0)
		btfss	STATUS,C
		bcf		cd,0	;if cd,0=0, decf Nr
		btfsc	STATUS,C
		bsf		cd,0	;vxo=vxo-step  Down Carry Flag// C bitcd.0=0
		btfss	cd,0
		bsf		TCskp,0	; Not skip TC56set		

		movlw	D'1'
		btfss	cd,0	;;STATUS,C łCarry̑
		subwf	nr0,1	;nr0= nr0+ (256-1)
		btfsc	STATUS,C
		goto	sub_2
		decf	nr1,1
		bsf		p_chk,0	;if nr1 change, then p_chk,0=1

sub_2	movlw	H'12'	;nr=H'11D6' =45.66MHz 
		subwf	nr1,0		;W=nr1 +(256- H'12' )
		movlw	H'11'
		btfsc	STATUS,C	;if nr1 >= 12
		goto	sub_3

		movwf	nr1		;@nr=H'11D6' =45.66MHz
		movlw	H'D6'
		subwf	nr0,0		;;W=nr0 +(256- H'D6' )
		btfsc	STATUS,C	;if nr0<H'D6' , nr0=H'D6'
		goto	sub_3
		movlw	H'D6'
		movwf	nr0

sub_3	movlw	D'56'
		btfsc	cd,0	;if cd.0=0, then Carry down
		movlw	D'0'						
		subwf	vxo,1	;W= vxo+ (256-56)
		;goto	pop
		return
;----------------
; N@XebvSW(RB.6)Ɓ@SG(3.04MHz)ŋNB
SG_st	call	readb		;input mode portb
		btfss	PORTB,6	;Push SW Trap
		goto	SG_st

		movlw	D'8'		;SG(AD9833 3.5MHz`0g)
		movwf	Nband		;3.5MHband set Nr4872=H'1308'@
		call	Bnd_chg		;setting nr0, nr1	;// H'1308'-H'11D6'=H'132'=D'306'3.06MHzU
		clrf	vxo
		call	S_AD98		;;AD9833ւ́@ Hf4E55FB6=@3.060MHz

Smain 	call	writb
		call	S_AD98		;;AD9833ւ́@ Hf4E55FB6=@3.060MHz
		call	Sputfre		;gvZ
		call	put1st

Smain5	call	readb		;input mode portb
		btfsc	PORTB,6
		goto	Smain7
		call	stp_chg ; StepύX
Smain6	btfss	PORTB,6	;Push SW Trap
		goto	Smain6

Smain7	btfss	vfc,0	;
		goto	Smain5	;
		goto	Smain

;------------------------------------------------------
start	bsf  	STATUS,RP0	;oN1		
		movlw	B'01110100'	;OSC=8MHz
		movwf	OSCCON
		bcf  	STATUS,RP0	;oN0

		movlw	D'255'
		movwf	wait_cn
		call	wait_ms

		bsf  	STATUS,RP0	;oN1
		movlw	B'00111111'	;RBvAbv;;INTEDG=FallEdge
		movwf	OPTION_REG	

		movlw	B'01001110'	;pinset(AN4=D,AN3=D,AN2=D,AN1=D,AN0=Analog, Vref+=5V, Vref-=GND) 
		movwf	ADCON1	;Left Justified 

		movlw	B'11100001'	;ra1,2,3,4,  inputoutput
		movwf	TRISA
		bcf  	STATUS,RP0	;oN0
		clrf	PORTA

		bsf  	STATUS,RP0	;oN1
		movlw	B'01111111'	;rb.0-rb.6sin  !rb,#11111111b	
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0
		clrf	PORTB

		movlw	B'00011000'
		movwf	old45	;
		movwf	new45	;
		clrf	SG

		call	adloop
		call	IFset

st1		call	readb	;rb.2-7s input mode
		movf	PORTB,0
		andlw	B'00000010' ; Masking RBport other than RB.1
		movwf	new1
		movwf	old1
		clrf	Nband
		call	Bnd_chg		;setting nr0, nr1
		
		call	writb
		call	TC56set			;TC9256P wakeupł
		call	TC56MD		;TC9256P wakeupł
		call	TC56set			;TC9256P {ł
		call	TC56_2set			;TC9256P_2 wakeupł
		call	TC56_2set			;TC9256P_2 {ł

		movlw	D'236'
		movwf	Hz200
		movlw	H'00'		;AD9833g@1999.5117(D'53673984'='H'03 33 00 00')
		movwf	Freq0
		movlw	H'00'		;
		movwf	Freq1
		movlw	H'33'		;
		movwf	Freq2
		movlw	H'03'		;
		movwf	Freq3
		;XO  10MHz덷@Fadj
		clrf	Fadj	;if Fadj.3=1,plus(MCR_H) else minus. Fadj.2=400,Fadj.1=200,Fadj.0=No Adjust
		btfsc	PORTA,5		;if MCR port H?, Fadj,3=1
		bsf		Fadj,3
		bcf		DAT   ;	PORTB,7	
		nop
		btfsc	PORTB,1 ;if RB1=L, 	Fadj,0=1 else 0	
		goto	st3
		bsf		Fadj,0

		bsf		DAT   ;	PORTB,7	
		nop
		bsf		Fadj,1	;Fadj.1=200 adjust,
		btfss	PORTB,1 ;if RB1=L, 	Fadj,0=1 else 0	
		goto	st3
		bcf		Fadj,1	;Fadj.1=200 NO adjust,
		bsf		Fadj,2	;Fadj.2=400 adjust,

st3		call	writb
		call	AD98wake			;AD9833 wakeup//Power up
		call	AD98fin		;I
	
		movf	PORTB,0
		andlw	B'00000001' ; Masking RBport other than RB.0
		movwf	Encx4		;if Encx4,0=L, then Encoder non-click4{@ 

		clrf	VCOport

st4		call	readb	;rb.2-7s input mode
		movf	PORTB,0
		andlw	B'01001110' ; Masking RBport other than RB.1,2,3-6
		movwf	old16
		movwf	new16
		call	adloop
		call	IFset

		movlw	B'11000000'
		movwf	ORb06
		movlw	B'11001110'
		movwf	NRb06

		movlw	D'1'
		movwf	het

start0	movlw	H'55'	;PLL Lock=L, else U 
		movwf	plk

		movlw	B'00000000'
		movwf	VCOport		;=o5/xx/xx/xx/ o4/o3/o2/o1, 0=High(OFF), 1=Low(ON)

		call	readb	;rb.2-7s input mode	;d SG step-SW ON
st00	btfsc	PORTB,6	;if STEP=L, then reset
		goto	st05
st01	bsf		SG,0	;if SG.0=1, goto SG(AD9833 3.5MHz`0g)
		btfss	PORTB,6	;
		goto	st01		;reset@to start1
		goto	start1

st05	call	load_1st
		movlw	B'00000001'
		subwf	stROM,0	 
		btfss	STATUS,Z	;if stROM=1, then st07 & Load_m else atart1
		goto	start1

st07	call	load_m		;EEPROM #0(mode) &01h-o5hԒnload
							;stROM, vxo,	nr0,	nr1,	Nband- 5A
		movf	stROM,1	; if stROM=0, then init EEPROM save(sav_ini)
		btfss	STATUS,Z
		goto	start3

start1	movlw	B'00000001'	
		movwf	stROM ;stROM=1
		clrf	Nband
		call	Bnd_chg		;B_7  1(7MHz)//setting nr0, nr1, het
		bsf		p_chk,0	;in order to check VCO_Num
		call	setVCO

		call 	sav_ini		; ̏EEPROMւ save
		goto	start35

start3 	nop		; ==
		movlw	D'1'
		movwf	het
		call	adloop
		call 	IFset
		nop		; ==

start35	clrf	TCskp
		bsf		TCskp,0	 	;Not skip TC56set
		call	writb
		call	RX	;nr1/nr0 setting
		
		call	TC56MD	;port PLL^Lock(OT4) set
		call	wt15ms
	;	call	wait_255	;waite 255msec for PLL Lock
		call	wait_255	;waite 255msec for PLL Lock
		call	TC56LK		;if PLL lock, plk=uLv=04ch, else plk=uUv=055h
		call	putfre		;LED1sځ@kHzvZ

		movlw	D'200'
		movwf	step0
		call	stp_chg		;step0 200  1(50Hz)
	;	call	put1st
		call	readb

start4	call	writb
		call	TC56MD	;port PLL^Un Lock(OT4) set

S_end	movlw	B'00001000'			;GIE=0 disable, INTE(RB4-7 Port Change)=1 enable
		movwf	INTCON	; 
 		bsf		INTCON,7	;荞݊Jn 

		clrf	vfc
		bsf		vfc,0
		clrf	p_chk
		bsf		p_chk,0
		clrf	TCskp
		bsf		TCskp,0

		btfsc	SG,0		;if SG.0=1, then goto SG(AD9833 3.5MHz`0g)
		goto	SG_st

main	bcf		vfc,0
		btfsc	p_chk,0	;if nr1 change, then p_chk,0=1
		call	setVCO		;nr1ύX́@VCO_num	Check, Hz200@Change
		btfsc	TCskp,0	;if TCskp=1, not skip set_50Hz
		call	set_50Hz
		nop
main1	call	writb	;Rb.4-7 o̓|[g
		call	TC56MD	;port PLL^Un Lock(OT4) set
		call	RX			;TC9256P nr0, nr1 & AD9833vxo
		call	TC56LK		;if PLL lock, plk=uLv=04ch, else plk=uUv=055h
	;	bcf		INTCON,7	;荞݋֎~ 
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
	;	bcf		INTCON,7	;荞݋֎~

main15	call	put1st
main2	;bcf		INTCON,7	;荞݋֎~ 
		bsf		INTCON,7	;荞݊Jn 
main4	bcf		vfc,0
	;----------------
main5	call	readb		;input mode portb
		bsf		INTCON,7	;荞݊Jn
main51	call	wt5u		;5 usec҂		
		btfsc	vfc,0	;
		goto	main	;
main53	call	chk16	;;RB1,2,3-6 ̓`FbN
				;Band, Memo, Step,  ??
		bsf		INTCON,7	;荞݊Jn

		movf	PORTB,0		;Encoder@old45Axor45bit ̓ǂݍ 
		andlw	B'00110000'	
		movwf	old45	;
		bcf		INTCON,7	;荞݋֎~
		movwf	xor45bit
		bcf		STATUS,C  ;Old45bit 2bit shift up
		rlf		xor45bit,1
		bcf		STATUS,C  ;
		rlf		xor45bit,1
		bsf		INTCON,7	;荞݊Jn

main7	btfss	vfc,0	;
		goto	main51	;
		goto	main
;----------------------------
;-------------------------------
chk16	call	readb		;input mode portb	
		movf	PORTB,0		
		andlw	B'01001110'	;Rb1,2,3,6̂ݎc
		movwf	new16	
		subwf	old16,0
		btfsc	STATUS,Z	;if new16=old16, then return
		return
	
c16set	bcf		INTCON,7	;荞݋֎~
		movf	new16,0		;mov	old16,new16
		movwf	old16

		btfsc	new16,3		;RB3;Band change	 
		goto	c16s01

		call	Bnd_chg

		call	writb
		call	TC56MD	;port PLL^Un Lock(OT4) set
		bsf		TCskp,0
		call	RX			;TC9256P nr0, nr1 & AD9833vxo
		call	wt15ms
		call	TC56LK		;if PLL lock, plk=uLv=04ch, else plk=uUv=055h

		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
		call	put1st
		call	TC56LK		;if PLL lock, plk=uLv=04ch, else plk=uUv=055h		
		goto	ch16e

c16s01	btfss	new16,2		;if Rb.2=L, then Memo Save
		goto	Memo

c16s03	btfss	new16,6		;if Rb.6=L, then Step_change
		goto	stp_chg

ch16e	movlw	D'100'
		movwf	wait_cn
		call	wait_ms
		return

;----------------------------------
RX		call	writb
		btfss	TCskp,0	;if TCskp=0, skip TC56set
		goto	RX1
		call	TC56set	;nr1/nr0 setting
RX1		call	AD98RX
		bcf		TCskp,0		;set Skippig TC56set
		return
;-------------------
;	RA0;A/DϊJn@@AN0|[g@AiO;;;̓dɂAg\@-6.4`+6.4kHz炷B	
adloop	movlw	B'01000001'	;set AD_channel=AN0, conversion_clock=16Tosc, )  
		movwf	ADCON0

		movlw	D'25'		;acquisition time wait 25usec
		movwf 	wait_cn	
		call	wait_us 

		bsf  	ADCON0,GO
ad_pol	nop  
		btfsc	ADCON0,GO
		goto	ad_pol		;AD conv polling
		movf	ADRESH,0
		movwf	mV		;ADϊLeft Justified@mVɎ荞݁@(0-127)
		bcf		STATUS,C
		rrf		mV,1	;Left Justified 1/2@mVɎ荞݁@(0-127)

		bcf  	ADCON0,0	;AD OFF
		bcf  	ADCON0,GO	;AD conv reset
		return
;--------------------------------
stp_chg		;    50Hz(step0=1), 0.5k(step0=10), 10kHz(step0=200)  

stp_1	movf	step0,0
		sublw	D'1'	;; step0=1 ??
		btfsc	STATUS,Z
		goto	st05k
		goto	stp_2

stp_2	movf	step0,0
		sublw	D'10'	;; step0=10 ??
		btfsc	STATUS,Z
		goto	st10k
		goto	st50

st50	movlw	D'1'
		movwf	step0
		goto	stend

st05k	movlw	D'10'
		movwf	step0
		goto	stend

st10k	movlw	D'200'
		movwf	step0
		goto	stend

stend	call	dp_step
		call	put1st		;stepύX\
		goto	ch16e
	;	;return
	;------------------
dp_step	movlw	D'10'	;if step=0.5kHz, Dsp9="c"
		subwf	step0,0
		movlw	H'c'
		btfsc	STATUS,Z
		movwf	Dsp9

		movlw	D'200'	;if step=10kHz, Dsp9="Blanc"
		subwf	step0,0
		movlw	H'f'
		btfsc	STATUS,Z
		movwf	Dsp9

		movlw	D'1'	;if step=50Hz,Dsp9=dec9
		subwf	step0,0
		btfss	STATUS,Z
		return
		
		movf	dec9,0
		movwf	Dsp9
		return
;----------------------------
Bnd_chg		;3.5, 7, 10,14,18,21,24.5,28MHz		
			; 0 , 1 , 2, 3, 4, 5,   6, 7, =Nband
		incf	Nband,1	;Nband= Nband+1 (0<= Nband <=7)
		movf	Nband,0
		sublw	D'8'
		movlw	D'0'	
		btfss	STATUS,Z
		movf	Nband,0
		movwf	Nband
		goto	setBand	;setting nr0, nr1, het
		;return
;------------
setBand	call	B_data ;;setting nr0,nr1 & het, VXO
		bsf		p_chk,0	;if nr1 change, then p_chk,0=1
		bsf		TCskp,0	;;GRX1ǉ
;------------------
setVCO	btfss	p_chk,0
		return

		bcf		p_chk,0
		clrf	poi
		movlw	D'2'
		movwf	cn
setV1	movf	poi,0
		call	VCO_Nr1
		movwf	x0	;temp VCO_nr1
		subwf	nr1,0	;W=nr1 +(256- VCO_nr1)
		btfss	STATUS,C	;if nr1 < VCO_nr1, then C=0 & goto setV2
		goto	setV2
		incf	poi,1
		decfsz	cn,1
		goto	setV1 
	;	return
setV2	movf	poi,0
		call	VCO_set	;VCO port of TC9256P
		movwf	VCOport

		movf	poi,0
		call	VCOname	;;VCO name ?A/B/C/D@VCO_n
		movwf	VCO_n
	;	;return
		call	TC56MD	;;VCOύX VCO port set

		btfsc	TCskp,0	;if TCskp=1, not skip set_50Hz
		call	set_50Hz
		bcf		TCskp,0	;GRX1ǉ
		nop
		return
;-----------Hz200(50HzAD9833 step) set
	;poi=[(PLL Nr)/64]@-71  ;  ĺA200Hź@AD9833 Freq Phase//lx vxo/4̏v
set_50Hz
		movf	nr1,0		;@nr=H'11D6' =45.66MHz`@@nr=H'1DFF'  =76.79MHz 
		movwf	poi
		movf	nr0,0
		movwf	x0
		bcf		STATUS,C		;poi= poi x 2/256
		rlf		x0,1
		rlf		poi,1
		bcf		STATUS,C		;poi= poi x 4/256
		rlf		x0,1
		rlf		poi,1

		movlw	D'71'
		subwf	poi,1	;poi= poi+ (256-71)

		movlw	D'49'		;poi must be <= 49
		subwf	poi,0		;W= poi + (256-49)
		movlw	D'49'
		btfss	STATUS,C	;if poi <=49,  poi = poi, else D'49'
		movf	poi,0
		movwf	poi

		movf	poi,0		;poi=(4/256)-D'71' =(1/64)-D'71'
		call	step200	;
		movwf	Hz200
	;	bcf		TCskp,0	;reset TCskp=1, 
		return

;--------------------------------------------------------
TC56set	movf	nr0,0	;PLL @nr1, nr0
		movwf	x0
		movf	nr1,0
		movwf	x1
	
		movlw	H'D0'	;mov	d8,#0d0h		;gύX
		movwf	d8
		movlw	B'10011001'	;FML_in Pin11́@VCO>40MHz PORTA.5(MCR)=L
	;	btfsc	PORTA,5	;if MCR=H, then (1- 1/1024)
	;	movlw	B'10101001'	;AM_in Pin10́@VCO<40MHz, PORTA.5(MCR)=H	
		movwf	x2
		;mov	x[2],#10011001b		;OSC2/OSC1/Mode/FM/  R3/R2/R1/R0=10 01 1001b
		goto	TC56in			;  	OSC=7.2MHz, FML, fref=9kHz (ref=10kHz@8MHz)

TC56MD	movlw	H'D2'	;mov	d8,#0d2h		;VCOύXA 
		movwf	d8
		movlw	B'10100000'	
		movwf	x0		;mov	x[0],#10100000b	
						;reset/DOHZ/CLK/IF2/IF1/SC/G1/G0
						;1UL  /0   /1  /0  /0  /0 /0--0
		movlw	B'01001010'	
		movwf	x1		;mov	x[1],#01001010b		
						;o1 /M6 /M5 /x /x /XT /TEST/Start/xx	
						; /0  /1  /0 /0 /1  /0   /1    /0    /xx@	
						;Start=counter start bit, Reset=Unlock reset_bit
						;rrf1bitEւ;#1bit=start bit
		movlw	H'4c'		;if PLL lock, then plk=uLv=04ch,
		subwf	plk,0
		movlw	B'00000000'
		btfsc	STATUS,Z	;if plk=uLv=04ch,
		movlw	B'00001000'	;port o4="h" ;1

		xorwf	VCOport,0		;=o5/xx/xx/xx/ o4/o3/o2/o1, 0=High(OFF), 1=Low(ON)
		andlw	B'00001111'
		movwf	x2		;mov	x[2],OT		
						;o6/o5/xx/xx/xx/ o4/o3/o2/o1
						;x /x /x /x /x / 0 /0 /0 /0
						;rrf1bitEւ;0bito1(OT-1)́Ax[1].7ֈړ
		bcf		STATUS,C
		rrf		x2,1		;OT.0 x[1],7Ɉړ
		rrf		x1,1
TC56in	call	writb
		bsf		PRD		;PERIOD=g
		bsf		T56		;Clock=H
		bsf		DAT		;Data=H
		nop
		movlw	D'32'	;mov	cn,#32
		movwf	cn
		bcf		PRD
TC57in	rrf		x2,1
		rrf		x1,1
		rrf		x0,1
		rrf		d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc 	STATUS,C
		bsf		DAT

		bcf		T56		;ǂݍ
		nop		;ێ1secȏ
		nop
		bsf		T56		;NbNŃf[^L
		nop		;ێ1secȏ
		nop
		bsf		PRD		;PERIOD=g
		decfsz	cn,1	;	djnz	cn,TC57in
		goto	TC57in

		bcf		PRD
		nop
		nop
		bsf		PRD
		return
;--------------------------------------------------------
TC56LK	movlw	H'D3'		;mov	d8,#0d3h		;PLL locko
		movwf	d8		
TC56out	call	writb
		bsf		PRD		;PERIOD=g
		bsf		T56		;Clock=H
		bsf		DAT		;Data=H
		movlw	D'8'	;mov	cn,#8
		movwf	cn
		bcf		PRD
TC58out	rrf		d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc 	STATUS,C
		bsf		DAT

		bcf		T56		;ǂݍ
		nop		;ێ1secȏ
		nop
		bsf		T56		;NbNŃf[^L
		nop		;ێ1secȏ
		nop
		bsf		PRD
		decfsz	cn,1	;djnz	cn,TC58out
		goto	TC58out

		bsf		STATUS,RP0	;oN1
		bsf		TRISB,7		; Rb7sIN
		bcf		STATUS,RP0	;oN0

		movlw	D'24'	;mov	cn,#24
		movwf	cn
TC60out	bcf		T56		;M󂯎ck
		nop		;Wait 1usec
		nop
		bsf		T56		;ckオŗL
		btfss	DAT
		bcf		STATUS,C	
		btfsc	DAT
		bsf		STATUS,C	
		
		rrf		y2,1		;Mf[^ y[2],7 ɓ
		rrf		y1,1
		rrf		y0,1
		decfsz	cn,1	;djnz	cn,TC60out
		goto	TC60out
		bcf		PRD
		nop	;ێ1secȏ
		nop
		bsf		PRD
		
;		btfss 	y0,0		;TC9256P UL bit EnableƂȂȂ
;		goto	TC56out		;̃[`甲oȂII
;		btfsc 	y[2],5
;		goto	TC56out

;TC61		movlw	00001111b
;		andwf	y[2],1 	

		bsf		STATUS,RP0	;oN1
		bcf		TRISB,7		; Rb6sout ??
		bcf		STATUS,RP0	;oN0

		movlw	H'4c'		;if PLL lock, then plk=uLv=04ch,
		btfsc	y0,1		;PLL lock1bit=0
		movlw	H'55'		;if PLL-UNLock, then  plk=uUv=055h
		movwf	plk
		return
;--------------
;--------------------------------------------------------
TC56_2set
		movlw	H'20' ;nr0,0	;PLL (1/18)=H'0120'    @
		movwf	x0
		movlw	H'01'
		movwf	x1
	
		movlw	H'D0'	;mov	d8,#0d0h		;gύX
		movwf	d8
		movlw	B'10001110'	;OSC2/OSC1=10(7.2MHz),  Mode/FM=00([hLF(ڕ),R3/R2/R1/R0=1110(100kHz)	
		movwf	x2
				;mov	x[2],#10011001b		;OSC2/OSC1/Mode/FM/  R3/R2/R1/R0=10 01 1110b
		goto	TC56_2in			;  	OSC=7.2MHz, FML, fref=100kHz (ref=111kHz@8MHz)

TC56_2in
		call	writb
		bsf		PRD		;PERIOD=g
		bsf		T56_2		;Clock=H
		bsf		DAT		;Data=H
		nop
		movlw	D'32'	;mov	cn,#32
		movwf	cn
		bcf		PRD
TC57_2in	rrf		x2,1
		rrf		x1,1
		rrf		x0,1
		rrf		d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc 	STATUS,C
		bsf		DAT

		bcf		T56_2		;ǂݍ
		nop		;ێ1secȏ
		nop
		bsf		T56_2		;NbNŃf[^L
		nop		;ێ1secȏ
		nop
		bsf		PRD		;PERIOD=g
		decfsz	cn,1	;	djnz	cn,TC57in
		goto	TC57_2in

		bcf		PRD
		nop
		nop
		bsf		PRD
		return
;--------------------------------------------------------
;AD9834g@1999.5117(D'53673984'='H'03330000')`Min. 1999.0677(D'53662065'=H'0332D171')   //i@j́AAD9833Phasel
;@@@@@@50Hzł́@Phaseĺ@
;===============
AD98wake
ddsinit	movlw	B'00100001' ;䃏[h  reset=0bit 1 //Ref.AiOfoCX an-1070
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		goto	dds1

AD98fin	movlw	B'11000000' ;䃏[h  reset=0bit 0 //ʑWX^0 MSB
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		call	dsdata	;f[^@16bit 

		movlw	B'00100000' ;䃏[h  reset=0bit 0 //Zbg̏I
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		call	dsdata	;f[^@16bit 
		return
		;---------------------------
		;-----ȉ-SGN̂ݎgp------
S_AD98	clrf	x2		;SGł́@(AD9833)Ń@R}h@
		movf	nr1,0
		movwf	x1
		movf	nr0,0
		movwf	x0
		
		clrf	y2
		movlw 	H'11'		;y =Nr -H'11D6'Hf132f	;NNr=H'1308'/// Hf132f@3,060HzU@
		movwf	y1
		movlw 	H'D6'		;
		movwf	y0			; y =Nr -H'11D6'	;NNr=H'1308
		call	sub_xy		;Z@(24bit)(24bit)|y(24bit)@;16 cycle
		movf	x1,0
		movwf	Snr1	;Snr= Nr -H'11D6'
		movf	x0,0		;; 
		movwf	Snr0

		movlw	H'4'
		movwf	val2
		movlw	H'18'
		movwf	val1
		movlw	H'93'
		movwf	val0

		movf	Snr1,0	;̌
		movwf	N
 		call	mult_vN	;|Z		x[32bit]=val[24bit] * N[8bit]
						;			x[32bit]= H'4 18 93' * N[8bit]
		movf	x2,0
		movwf	Freq3
		movf	x1,0
		movwf	Freq2		
		movf	x0,0
		movwf	Freq1
		clrf	Freq0		

		movlw	H'4'		; Freq(10kHz)D'268435' = H'4 18 93'
		movwf	val2
		movlw	H'18'
		movwf	val1
		movlw	H'93'
		movwf	val0

		movf	Snr0,0	;̌
		movwf	N
 		call	mult_vN	;|Z		x[32bit]=val[24bit] * N[8bit]
						;			x[32bit]= H'4 18 93' * N[8bit]
		movf	x3,0
		movwf	y3
		movf	x2,0
		movwf	y2
		movf	x1,0
		movwf	y1
		movf	x0,0
		movwf	y0
						
		call	add_Fy	;; 	Z	Freq(32bit)Freq(32bit)+ y(32bit)
						;;l@Freq(32bit)H'4 E5 5F b6'
		clrf	val2	
		movlw	H'5'		;D'1342'=H'53E'  //50Hz ́@AD9833 step
		movwf   val1
		movlw	H'3e'		;
		movwf   val0
	
		movf	vxo,0		;
		movwf   N
		call	mult_vN		;x[32bit]=val[24bit] * N[8bit]
		clrf	y3
		movf	x2,0
		movwf	y2
		movf	x1,0
		movwf	y1		
		movf	x0,0
		movwf	y0
		call	add_Fy	;; 	Z	Freq(32bit)Freq(32bit)+ y(32bit)
		goto	AD98_S



		;-------------
	;			;ޑoɂDDS set
			;FREQ0ɏ݁Ao͂ ;@about 800cycle //0.4msec
AD98set;	bcf		INTCON,7	;荞݋֎~ 
		movlw	B'00100000' ;䃏[h  Freq0; D15, D14=0  D13(B28;14MSB+ 14LSB)=1 D11(Freq0)=0 
		movwf	CtbU
		movlw	B'00000000'  ;TCg䃏[h D7()sleep1)=0, D6isleep2;DACj=0, D1(MODE)=0 B'00000000'
							; OpgƂꍇ́AD6(sleep2)=1, D1(MODE)=1 CtbL=B'01000010' 
		movwf	CtbL
		clrf	Reg_Freq
		goto	dds1

AD98TX	bcf		INTCON,7	;荞݋֎~ 999
		movlw	B'00101010' ;䃏[h  Freq1; D15, D14=0  D13(B28;14MSB+ 14LSB)=1 D11(Freq0)=0 D9(PINSW)=1
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		bsf		Reg_Freq,0	; if Reg_Freg=1, Write to Freq Regist1,
		goto	dds1

AD98RX  movlw	H'00'		;AD9834g@1999,511.719Hz(D'53,673,984'='H'03 33 00 00')
		movwf	Freq0
		movlw	H'00'		;
		movwf	Freq1
		movlw	H'33'		;
		movwf	Freq2
		movlw	H'03'		;
		movwf	Freq3

		btfss	Fadj,0	;if Fadj.3=1,plus(MCR_H) else minus. Fadj.2=400,Fadj.1=200,Fadj.0=No Adjust
		goto	AD98R8
		btfsc	Fadj,3		
		goto	AD9R_L ;goto Minus␳( XO>10.0MHz )
		goto	AD9R_P ;goto Plus␳( XO<10.0MHz )

AD9R_P	btfss	Fadj,1	
		goto	AD9R_P2
		call	add_Freq	;FreqZ	Freq(32bit)Freq(32bit)+ D'200' //y0=200
		goto	AD98R8

AD9R_P2	call	add_Freq	;FreqZ	Freq(32bit)Freq(32bit)+ D'200' //y0=200
		call	add_Freq	;FreqZ	Freq(32bit)Freq(32bit)+ D'200' //y0=200
		goto	AD98R8

AD9R_L	btfss	Fadj,1	
		goto	AD9R_L2
		call	sub_Freq	;FReqZ		Freq(32bit)Freq(32bit)|D'200'@//y0=200
		goto	AD98R8

AD9R_L2	call	sub_Freq	;FReqZ		Freq(32bit)Freq(32bit)|D'200'@//y0=200
		call	sub_Freq	;FReqZ		Freq(32bit)Freq(32bit)|D'200'@//y0=200
		goto	AD98R8

AD98R8	call	MultHz		;y1_y0 (16bit)= [ Hz200(8bit) x vxo(8bit) ] x1/4	
		call	sub32_Fy	;	Freq(32bit)Freq(32bit)-y(32bit)

AD98_S	bcf		INTCON,7	;荞݋֎~ 
		movlw	B'00100010' ;䃏[h  Freq0; D15, D14=0  D13(B28;14MSB+ 14LSB)=1 D11(Freq0)=0 D9(PINSW)=1
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		bcf		Reg_Freq,0	; if Reg_Freg=0, write to Freq Regist0,
		goto	dds1

dds1	nop
		;ݏ@CtbU(8bit)+CtbL(8bit)  00100000 00000000 ;Ref. to Table 11. AD9834 data
		;ݏ@LsbU(8bit)+LsbL(8bit)  01000000 00000000
		;ݏ@MsbU(8bit)+MsbL(8bit)  01111111 11111111  
		movf	Freq3,0	;g݁@Freq3(4bit) MsbU
		movwf	MsbU
		movf	Freq2,0	;g݁@Freq1(8bit) MsbL
		movwf	MsbL

		movf	Freq1,0	;g݁@Freq1(8bit) LsbU
		movwf	LsbU
		movwf	x1	;x1=Freq1	
		movf	Freq0,0	;g݁@Freq0(8bit) LsbL
		movwf	LsbL	;

		bcf		STATUS,C	;gData 14bit ݒ肷邽߁@rrf x2
		rlf		x1,1
		rlf		MsbL,1
		rlf		MsbU,1

		bcf		STATUS,C
		rlf		x1,1
		rlf		MsbL,1
		rlf		MsbU,1

		btfsc	Reg_Freq,0		;if Reg_Freg=0, Write to Freq Regist0(ʏ), if Reg_Freg=1, Write to Freq Regist1,
		goto	dds3
dds2	bsf		LsbU,6	;Regist Freq0 ݎw
		bcf		LsbU,7	;Regist Freq0 ݎw

		bsf		MsbU,6 	;Regist Freq0 ݎw
		bcf		MsbU,7 	;Regist Freq0 ݎw
		goto	dds4

dds3	bcf		LsbU,6	;Regist Freq1 ݎw
		bsf		LsbU,7	;Regist Freq1 ݎw

		bcf		MsbU,6	;Regist Freq1 ݎw
		bsf		MsbU,7 	;Regist Freq1 ݎw

dds4	call	dsdata	;f[^@16bit +gf[^@LSB@16bit +gf[^@MSB@16bit
		bsf		INTCON,7	;荞݊Jn
		return
	;----------------------
dsdata	movlw   D'48'
        movwf   cs
		bsf     FSY 	; AD9834 Fsync
		bsf		AD33CK  ;AD9834 SCK;clock:H
		bcf		FSY 
dsd1	call	rotate	;12cy
		bcf     AD33CK			;clock:L
		bsf		AD33CK  ;AD9834 SCK;clock:H
		decfsz	cs,1
        goto    dsd1

		bsf 	FSY			;FSYNC:H ۰ފ
		return

rotate	bcf		STATUS,C	;12cycle	;ް̑o
		rlf     MsbL,1		
		rlf     MsbU,1		;14bit MSB
		rlf     LsbL,1		
		rlf     LsbU,1		;14bit LSB
		rlf     CtbL,1
		rlf		CtbU,1

		btfss	STATUS,C			;DatacixMSBj𑗏o
		bcf     DAT			;
		btfsc	STATUS,C			;
		bsf     DAT			;
		return
;-----------------------
;    ---------------------------------------------------
load_1st
		movlw	H'0'
		movwf	ADDR
		movlw	D'1'      
		movwf	scn

		movlw	stROM   ;stROM, vxo,nr0,nr1,Nband- 5address  
		movwf	FSR
		goto	load_rt
;	;------------------------
;		;#00h   #01h    #02h    #03h	#04h	#05h	#06h	#07h
;		;stROM, vxo,	nr0,	nr1,	Nband- 5Aaddress	
load_m	movlw	H'0'
		movwf	ADDR
		movlw	D'5'      
		movwf	scn

		movlw	stROM   ;stROM, vxo,nr0,nr1,Nband- 5address  
		movwf	FSR
load_rt	bcf		STATUS,RP0	;Bank2/Select Bank of EEADR
		bsf		STATUS,RP1	;Bank2/
		
		movf	ADDR,0      	;EEPROM address 0&h
		movwf	EEADR		; Data Memory Address to read

		bsf		STATUS,RP0		;Bank3/	Select Bank of EECON1
		bcf		EECON1,EEPGD	; Select Bank of EECON1
		bsf		EECON1,RD		; EE Read

		bcf		STATUS,RP0		;Bank2/ Select Bank of EEDATA
		movf	EEDATA,0      
		movwf	INDF

		incf	ADDR,1
		incf	FSR,1
		decfsz	scn,1
		goto	load_rt

		bcf		STATUS,RP0	;Bank0
		bcf		STATUS,RP1
		return
;    ------------------------------------
Memo
sav_ini		;
		movlw	H'0'
		movwf	ADDR
		movlw	D'5'      
		movwf	scn

		movlw	stROM   ;stROM, vxo,nr0,nr1,Nband- 5Aaddress
		movwf	FSR
sav_i5	movf	INDF,W
		movwf	VALUE
		call	datawrite
		incf	ADDR,1
		incf	FSR,1
		decfsz	scn,1
		goto	sav_i5
		goto	ch16e
	;	;return
;   ----------------------------------------		
datawrite	
		bsf		STATUS,RP0	;Bank3
		bsf		STATUS,RP1	;Bank3/	Select Bank of EECON1

	;	bcf		EECON1,WR
dr1		btfsc	EECON1,WR	;Wait for write to complete
		goto	dr1

		bcf		STATUS,RP0	;Bank2/Select Bank of EEADR
		movf	ADDR,W
		movwf	EEADR		;Data Memory Address to write

		movf 	VALUE,W  	;
		movwf	EEDATA 		; Data Memory Value to write

		bsf		STATUS,RP0	;Bank3/	Select Bank of EECON1
		bcf		EECON1,EEPGD	;; Point to DATAmemory 	
		bsf		EECON1,WREN		;WRENޯ on; Enable writes

		bcf		INTCON,GIE 		; Disable INTs
	;-----
		movlw	H'55'
		movwf	EECON2
		movlw	H'aa'
		movwf	EECON2
		bsf		EECON1,WR 		; Set WR bit to begin write
	;-----
		bsf		INTCON,GIE 		; Enable INTs.
		bcf		EECON1,WREN 	; Disable writes

		call	wt15ms		; wait 15ms
		bcf		STATUS,RP0	;Bank0
		bcf		STATUS,RP1
		return
;**********************************************************************
;------------------------------		
putfre	; 5000step/ 170cycle+3600cycle= 3800cycle
;;Nr=4602̎̕\gvZ(100HzP)=(Nr-1) x(4+32+64) x(1- 1/(2^12) )+(VXO/2) -IF;45.158MHz=8407.6 
		;Upper Hetero  f(100HzP)=(Nr-1) x100+ vxo/2 -IF
		;Lower Hetero  f(100HzP)=(Nr-1) x100+ vxo/2 +IF
	;------;Nr x 100
		movf	nr0,0	;Nr x100= Nr x(4+32+64)
		movwf	val0
		movf	nr1,0
		movwf	val1
		clrf	val2

		movlw	1				;sub Nr= Nr-1
		subwf	val0,1
		movlw	1
		btfss	STATUS,C
		subwf	val1,1


		bcf		STATUS,C	;Nr=Nr x2
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		bcf		STATUS,C	;Nr=Nr x4
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		movf	val0,0		;x(0-2) =val(0-2) 		;x=Nr x (4)
		movwf	x0
		movf	val1,0
		movwf	x1
		movf	val2,0
		movwf	x2

		bcf		STATUS,C	;Nr=Nr x8
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		bcf		STATUS,C	;Nr=Nr x16
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		bcf		STATUS,C	;Nr=Nr x32
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		movf	val0,0		;y(0-2) =val(0-2) 
		movwf	y0
		movf	val1,0
		movwf	y1
		movf	val2,0
		movwf	y2
		call	add_xy	;(24bit)(24bit){y(24bit)@;x=Nr x (4+32)

		bcf		STATUS,C	;Nr=Nr x64
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		movf	val0,0		;y(0-2) =val(0-2) 
		movwf	y0
		movf	val1,0
		movwf	y1
		movf	val2,0
		movwf	y2
		call	add_xy	;(24bit)(24bit){y(24bit)@;x=Nr x (4+32+64)
	;------;Nr x 100  Ending
	;------------------------- Nr x100 x(1- 1/(2^10) )
		movf	x1,0		;val(0-2) = 1/(2^8) x val(0-2) 
		movwf	val0
		movf	x2,0
		movwf	val1
		clrf	val2

		bcf		STATUS,C	;val(0-2) = 1/(2^9) x val(0-2)
		rrf		val1,1
		rrf		val0,1	
		bcf		STATUS,C	;val(0-2) = 1/(2^10) x val(0-2) ;1/1024
		rrf		val1,1
		rrf		val0,1	
	;	btfsc	PORTA,5	;if MCR=H, then (1- 1/1024)
	;	goto	putf2

		bcf		STATUS,C	;val(0-2) = 1/(2^11) x val(0-2) ;1/2048
		rrf		val1,1
		rrf		val0,1	
		bcf		STATUS,C	;val(0-2) = 1/(2^12) x val(0-2) ;1/4096
		rrf		val1,1
		rrf		val0,1	

putf2	movf	val0,0		;y(0-2) =val(0-2) 
		movwf	y0
		movf	val1,0
		movwf	y1
		movf	val2,0
		movwf	y2
		call	sub_xy	;(24bit)(24bit)|y(24bit)//=Nr x100 x(1- 1/(2^12) )				
	;------------------------- Nr x100 x(1- 1/(2^12) ) Ending
		movf	vxo,0		;W= vxo 
		movwf	y0
		bcf		STATUS,C
		rrf		y0,1	;y0=1/2 *vxo
		call	add_xy8	;(24bit)(24bit)+y(8bit)@//Nr x100 x(1- 1/(2^10)) + vxo/2
	;---------
		call	adloop
		call	IFset
		movf	if0,0		;y= IF setting 
		movwf	y0
		movf	if1,0
		movwf	y1
		movf	if2,0
		movwf	y2

		movlw	D'1'	;if D'1', then Up Hetro
		subwf	het,0
		btfsc	STATUS,Z
		goto	pf_U

pf_L	call	add_xy	;(24bit)(24bit){y(24bit) //x= x+IF
		goto	pf3

pf_U	call	sub_xy	;(24bit)(24bit)|y(24bit) //x= x-IF
		
pf3		movf	x0,0	
		movwf	val0
		movf	x1,0	
		movwf	val1
		movf	x2,0	
		movwf	val2
		clrf	val3		

		call	dcmain		;16i-10iϊ	/4900step
		call	dp_step
	;----------///Frequebcy Calc. Ending
		return
;--------------------
Sputfre	; SĜƂ̌vZG@5000step/ 170cycle+3600cycle= 3800cycle
;;Nr=4602̎̕\gvZ(100HzP)=(Nr-1) x(4+32+64) x(1- 1/(2^12) )+(VXO/2) 

	;------;Nr x 100
		movf	Snr0,0	;SNr x100= SNr x(4+32+64)
		movwf	val0
		movf	Snr1,0
		movwf	val1
		clrf	val2

		bcf		STATUS,C	;Nr=Nr x2
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		bcf		STATUS,C	;Nr=Nr x4
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		movf	val0,0		;x(0-2) =val(0-2) 		;x=Nr x (4)
		movwf	x0
		movf	val1,0
		movwf	x1
		movf	val2,0
		movwf	x2

		bcf		STATUS,C	;Nr=Nr x8
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		bcf		STATUS,C	;Nr=Nr x16
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		bcf		STATUS,C	;Nr=Nr x32
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		movf	val0,0		;y(0-2) =val(0-2) 
		movwf	y0
		movf	val1,0
		movwf	y1
		movf	val2,0
		movwf	y2
		call	add_xy	;(24bit)(24bit){y(24bit)@;x=Nr x (4+32)

		bcf		STATUS,C	;Nr=Nr x64
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		movf	val0,0		;y(0-2) =val(0-2) 
		movwf	y0
		movf	val1,0
		movwf	y1
		movf	val2,0
		movwf	y2
		call	add_xy	;(24bit)(24bit){y(24bit)@;x=Nr x (4+32+64)
	;------;Nr x 100  Ending
		movf	vxo,0		;W= vxo 
		movwf	y0
		bcf		STATUS,C
		rrf		y0,1	;y0=1/2 *vxo
		call	add_xy8	;(24bit)(24bit)+y(8bit)@//Nr x100 + vxo/2
		
Spf3	movf	x0,0	
		movwf	val0
		movf	x1,0	
		movwf	val1
		movf	x2,0	
		movwf	val2
		clrf	val3		

		call	dcmain		;16i-10iϊ	/4900step
		call	dp_step
	;----------///SG Frequebcy Calc. Ending
		return

;--------------------
	;-------
TM_cmd	call	TM_data
		call	TM_Ack
		call	wt40u			;wait 40sec
		return
		;----------
TM_chara
		movf	d4,0		;d4=charactor code
		movwf	d8
		call	TM_data
		call	TM_Ack
		call	wt40u			;wait 40sec
		return
		;----------
		;----------
TM_Start		;SDA=PORTA,7	SCL=PORTA,6	
		bsf		STATUS,RP0	;oN1
		bcf		TRISA,7		;PORTA.7 output=SDA
		bcf		TRISA,6		;PORTA.6 output =SCL
		bcf		STATUS,RP0	;oN0
        bsf		SCL   ;PORTA,6=SCL=H
		nop
		nop
		bsf		SDA	
		nop
		nop
	    bcf		SDA   ;PORTA,7=SDA=L
		nop
		bcf		SCL   ;PORTA,6=SCL=L
		return		 
		;--------
TM_Ack	bsf		STATUS,RP0	;oN1
		bsf		TRISA,7		;PORTA.7 input=SDA
		bcf		STATUS,RP0	;oN0
		nop
M_A2	btfsc	SDA	
		goto	M_A2

M_LED	bsf		SCL		;SCL
		nop
		bcf		SCL		;SCL
		
		bsf		STATUS,RP0	;oN1
		bcf		TRISA,7		;PORTA.7 output=SDA
		bcf		STATUS,RP0	;oN0
		bcf		SDA
		return
		;----------

TM_data	bcf		SCL
		movlw	D'8'
		movwf	ct
M_d2	rrf  	d8,1
		btfss	STATUS,C
		bcf		SDA
		btfsc	STATUS,C
		bsf		SDA		
		nop
		bsf		SCL		;SCL
    	nop
		bcf		SCL		;SCL
		decfsz	ct,1		;djnz	ct,M_d2
		goto	M_d2
		return
	;-----------
TM_Stop	bcf		SDA
		bsf		SCL
		nop
		bsf		SDA		
		
		bsf		STATUS,RP0	;oN1
		bsf		TRISA,6		;PORTA.6 input =SCL
		bcf		STATUS,RP0	;oN0  ;////SCL=H
		nop
		bsf		STATUS,RP0	;oN1
		bsf		TRISA,7		;PORTA.7 input=SDA
		bcf		STATUS,RP0	;oN0  ;/////SDA=H
		return	
		;-----------
;--------------------
put1st		; 590step+680us
		call	TM_Start		
		movlw	B'01000000'		;Data command_1 setting//Auto increment
		movwf	d8		
		call	TM_cmd
		call	TM_Start

		movlw	B'11000000'		;Adress command_2 setting//C0H
		movwf	d8		
		call	TM_cmd

		;; ȉ@6\@increment
		clrf	poi	;tab_dp  1Ԗڕ\
		movlw	D'6'			
		movwf	cn
		call	dp_bun
		call	TM_Start

		movlw	B'10001111'		;Display command_3 setting//Pulse width 11/16
		movwf	d8		
		call	TM_cmd

		goto	TM_Stop

;-------;\郋[`	;\ZOǵAtab_dpɑΉ	;poi=ʒuA0<=poi<tab_dpmaxl
dp_bun		;\				;/16x(35step+40us)=560step+640us
dpb1	movf	poi,0
		call	tab_dp
		movwf	FSR
		movf	INDF,0
		andlw	B'00001111'
		call	tablenumb
		movwf	d4

		movf	poi,0
		call	tab_dot		;K5, K2ց@Dot\
		xorwf	d4,1			;f[^@Ɓ@Dotf[^́@XOR
dpb5	call	TM_chara		;
		incf	poi,1
		decfsz	cn,1
		goto	dpb1
		return
;--------------------------------------------------
readb	bsf		STATUS,RP0	;oN1	;rb.2-7s input mode
		movlw	B'01111111'	;rb.0-7sin  !rb,#11111111b
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		clrf	PORTB
		return

;---------
writb	bsf		STATUS,RP0	;oN1
		movlw	B'01111111'	; rb.7sout  	
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		return
;----------------
;---------------------------------------------------------------------------------
;		I[_[̃EFCg
;
wait_255
		movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_ms

wt15ms	movlw	D'15'	;mov	wait_cn,#15
		movwf	wait_cn
		goto	wait_ms

wt4ms	movlw	D'4'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt1ms	movlw	D'1'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt255u	movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_us

wt40u	movlw	D'40'	;wait 40sec
		movwf	wait_cn
		goto	wait_us

wt5u	movlw	D'5'	;mov	wait_cn,#5
		movwf	wait_cn
		goto	wait_us

wait_20	movlw	D'20'		;mov	wait_cn,#20
		movwf	wait_cn
wait_ms  	
wait_ms0	
		movlw	D'0'	;mov	wait_cn2,#0
		movwf	wait_cn2
wait_ms1
		movlw	2	
		movwf	cp
wait_ms2
		nop
		decfsz	cp,1
		goto	wait_ms2		
		decfsz	wait_cn2,1
		goto	wait_ms1	;djnz	wait_cn2,wait_ms1

		decfsz	wait_cn,1
		goto	wait_ms0	;djnz	,
		return
;
;		ʂI[_[̃EFCg
;
wait_us		
wait_us0
		decfsz	wait_cn,1	;djnz	wait_cn,wait_us0
		goto	wait_us0
		return
;	---------------	end of lcd.asm
;---------------------------------------------------------------------
;	24rbgoCiPOiϊ
;
;	val24rbgf[^uBi:val[2]:val[1]:va[0])
;
;	dcmainR[B
;
;	decɓi[B
;		(dec[2]:dec[3]:...:dec[8]:dec[9])
;		dec[2]ŏʌdec[9]ŉʌłB
;
;	ϊval͔j󂳂B
;
;	sample:
;		val	= 00:00:04:D2 h
;		dec	= 00:00:00:00:00:00:01:02:03:04
;                  dec(0):dec(1):(2):(3):(4):(5):(6):(7):(8):dec(9)
;						(1,234)
;
dcmain
		movlw	dec9		;;mov	fsr,#dec_top	; i[ꏊl
		movwf	FSR
		incf	FSR,1
		call	devide			; ŉʕϊ 
		call	devide			;10JԂ
	;	call	devide
	;	call	devide
		call	devide

		call	devide
dcm1	call	devide
		call	devide
		call	devide
		call	devide			; ŏʕϊ
		
zeroblank
		movlw	D'5'		;**.*MHz\̑2܂blank\
		movwf	cn			;Zero Blanku

		movlw	dec2	;movlw  dec0	;; dec[0]i[ꏊl
		movwf	FSR
zb1		movf	INDF,0
		btfss	STATUS,Z		;if dec[]=00, then continue, else return
		goto	zb3
zb2			;if dec[]=00, then dec[]=0fhł́Ablank \ƂȂ
		movlw	H'0f'	;Letter' Blanc'
		movwf	INDF	;movwf	indirect

		incf	FSR,1
		decfsz	cn,1
		goto	zb1

zb3		return

;
;		POTu[`
;		POŏZ܂
;
devide		
		movlw	D'24'		;	; 24rbgԂ
		movwf	cn
		clrf	val_m
devide0		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
	;	rlf		val3,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devide0

		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		movwf	INDF
		return
;----------------------------------------end of 10iϊ	
;	Z		(24bit)(24bit)|y(8bit)@
sub_xy8
		movf	y0,0				;sub	x[0],y[0]
		subwf	x0,1
		movlw	1
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1
	;	btfss	STATUS,C
	;	subwf	x3,1
		return

;-----------------------
;	Z		(24bit)(24bit)|y(24bit)@;16 cycle
sub_xy
		movf	y0,0				;sub	x[0],y[0]
		subwf	x0,1
		movlw	1
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1

		movf	y1,0				;sub	x[1],y[1];
		subwf	x1,1
		movlw	1
		btfss	STATUS,C
		subwf	x2,1

		movf	y2,0				;sub	x[2],y[2];
		subwf	x2,1		
		return
;--------------------------------------------------------------------
; 	Z	(24bit)(24bit){y(8bit)@
;
add_xy8				
		movf	y0,0				;add	x[0],y[0]
		addwf	x0,1
		movlw	1
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
	;	btfsc	STATUS,C
	;	addwf	x3,1
		return
;------------------------------------
; 	Z	(24bit)(24bit){y(24bit)@
;
add_xy				
		movf	y0,0				;add	x[0],y[0]
		addwf	x0,1
		movlw	1
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		
		movf	y1,0				;add	x[1],y[1]
		addwf	x1,1
								
		movlw	1
		btfsc	STATUS,C
		addwf	x2,1

		movf	y2,0				;add	x[2],y[2]	]
		addwf	x2,1
		return
;--------------------
;	Z		Freq(32bit)Freq(32bit)|y(32bit)@
;
sub32_Fy
		movf	y0,0		;sub	x[0],y[0]
		subwf	Freq0,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	Freq1,1
		btfss	STATUS,C
		subwf	Freq2,1
		btfss	STATUS,C
		subwf	Freq3,1
		
		movf	y1,0		;sub	x[1],y[1]
		subwf	Freq1,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	Freq2,1
		btfss	STATUS,C
		subwf	Freq3,1

		movf	y2,0		;sub	x[2],y[2]
		subwf	Freq2,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	Freq3,1
		
		movf	y3,0		;sub	x[3],y[3]
		subwf	Freq3,1
		return
;--------------------
sub_Freq	;FReqZ		Freq(32bit)Freq(32bit)|D'200'@//y0=200
		movlw	D'200'
		 ;movf	y0,0		;sub	x[0],y[0]
		subwf	Freq0,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	Freq1,1
		btfss	STATUS,C
		subwf	Freq2,1
		btfss	STATUS,C
		subwf	Freq3,1
		return
;--------------------
add_Freq	;FreqZ	Freq(32bit)Freq(32bit)+ D'200' //y0=200
		movlw	D'200'
		 ;movf	y0,0				;add	x[0],y[0]
		addwf	Freq0,1
		movlw	1
		btfsc	STATUS,C
		addwf	Freq1,1
		btfsc	STATUS,C
		addwf	Freq2,1
		btfsc	STATUS,C
		addwf	Freq3,1
		return
;------------------------------------------------------------
; 	Z	Freq(32bit)Freq(32bit)+ y(32bit)
add_Fy				
		movf	y0,0				;add	x[0],y[0]
		addwf	Freq0,1
		movlw	1
		btfsc	STATUS,C
		addwf	Freq1,1
		btfsc	STATUS,C
		addwf	Freq2,1
		btfsc	STATUS,C
		addwf	Freq3,1
		
		movf	y1,0				;add	x[1],y[1]
		addwf	Freq1,1
								
		movlw	1
		btfsc	STATUS,C
		addwf	Freq2,1
		btfsc	STATUS,C
		addwf	Freq3,1
		
		movf	y2,0				;add	x[2],y[2]	]
		addwf	Freq2,1
							
		movlw	1
		btfsc	STATUS,C
		addwf	Freq3,1

		movf	y3,0				;add	x[3],y[3]
		addwf	Freq3,1									
		return
;-----------------------------
;|Z@   y1_y0 (16bit)= [ Hz200(8bit) x (199- vxo(8bit)) ]x 1/4
;			y0 (16bit)= [Hz200 x val_m ] x 1/4	
;  ʂ́AY1,y0Ɏ[B@Hz200, vxó@ȂB vZߒval_mgp

MultHz	comf	vxo,0		;W=255- vxo
		movwf	val_m
		movlw	D'56'
		subwf	val_m,1		;val_m = val_m + (256- 56) = 199- vxo
		clrf	y3
		clrf	y2

		clrf   	y1
		clrf    y0
		movlw   D'8'
		movwf   cn
		movf    Hz200,0

Multlop	rrf     val_m,1			;val_m = 199- vxo
		btfsc   STATUS,C
		addwf   y1,1
		rrf     y1,1
		rrf     y0,1
		decfsz  cn,1
		goto    Multlop

		bcf		STATUS,C  ;y= y x 1/4 (200Hz  50Hz)
		rrf		y1,1
		rrf		y0,1
		bcf		STATUS,C
		rrf		y1,1
		rrf		y0,1
	 
		return
;-----------------------------------------------------------------------
;	|Z		x[32bit]=val[24bit] * N[8bit]
;
;	val 24rbgf[^uB
;		i:val[2]:val[1]:val[0]) 	vZߒ val_m g
;       N 8ޯްuB
;                 N ;  ő  #255łB
;
;	xɓi[B
;                ix[3]:x[2]:x[1]:x[0]) 
;       		
;	ϊ N ͔j󂳂ȂB
;
;
mult_vN	clrf		x3
		clrf		x2
		clrf		x1
		clrf		x0
		clrf		val_m			;ǉ1
			
		movlw 	D'8'
		movwf 	cn
mult0		
		btfss	N,0
		goto	mutpas

		movf	val0,0				;add	x[0],val[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	val1,0				;add	x[1],val[1]
		addwf	x1,1		
									
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	val2,0				;
		addwf	x2,1				;

		movlw	D'1'				;2021.03.22
		btfsc	STATUS,C			;2021.03.22
		addwf	x3,1				;2021.03.22

		movf	val_m,0				;2021.03.22
		addwf	x3,1				;2021.03.22	
									
mutpas	bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val_m,1		;ǉ1
		btfsc	STATUS,C
		bsf		val0,0

		bcf		STATUS,C
		rrf		N,1
		btfsc	STATUS,C
		bsf		N,7

		decfsz	cn,1			;	djnz	cn,mult0
		goto	mult0

		movlw	D'8'
		movwf	cn
multrot	bcf		STATUS,C
		rrf		val_m,1				;ǉ1
		rrf		val2,1
		rrf		val1,1
		rrf		val0,1
	;	btfsc	STATUS,C
	;	bsf		val3,7
		decfsz	cn,1			;djnz	cn,multrot
		goto 	multrot
		return
;---------------------------end of |Z
;-----------------------------------------------------
;	32rbgoCiZTu[`
;		val<32bit> = x<32bit> / y<16bit>; 
;
;	x 32 rbgf[^u܂B
;		ix[3]:x[2]:x[1]:x[0]) 
;       y 16ޯްu܂B
;              y[1]:y[0];  ő  H'FFFF'łB
;
;	val ɓi[܂B
;                ival[3]:val[2]:val[1]:val[0])  ]x[1][0]
;	vZ̉ߒ	Z		(32bit)(32bit)|y(32bit)gp
;       vZ̉ߒval[3]-val[0]Aval[0] ĝŒ`KvłB
;		
;
Div_xYY
		movf	y1,0		;y=y *256*256
		movwf	y3
		movf	y0,0
		movwf	y2
		clrf	y1
		clrf	y0
		movlw	D'17'			
		movwf	cn
		movlw	D'16'			
		movwf	cs
		clrf	val0
		clrf	val1
		clrf	val2
		clrf	val3

Dv1		movf	cs,1
		btfsc	STATUS,Z	;if y=0, can't divided then return
		return	
		btfsc	y3,7	;if y3.7 =0, then y rotate
		goto	Dv2
		bcf		STATUS,C
		rlf		y2,1
		rlf		y3,1
		incf	cn,1
		decfsz	cs,1
		goto 	Dv1		
				
Dv2		;;x>=y ? check
		movf	x3,0
		subwf	y3,0		; W=y3+ (256-x3)
		btfss	STATUS,C	; if y3<x3, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y3>x3, then Dv4
		goto	Dv4

		movf	x2,0
		subwf	y2,0		; W=y2+ (256-x2)
		btfss	STATUS,C	; if y2<x2, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y2>x2, then Dv4
		goto	Dv4

		movf	x1,0
		subwf	y1,0		; W=y1+ (256-x1)
		btfss	STATUS,C	; if y1<x1, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y1>x1, then Dv4
		goto	Dv4

		movf	x0,0
		subwf	y0,0		; W=y0+ (256-x0)
		btfss	STATUS,C	; if y0<x0, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y0>x0, then Dv4
		goto	Dv4
		goto	Dv3

Dv3		;x>=y@Ȃ̂ňZ
		call 	sub_xy	;(32bit)(32bit)|y(32bit)
		bsf		STATUS,C	
		goto	Dv5

Dv4		;x<y Ȃ̂ 
		bcf		STATUS,C	
Dv5		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1	
		decfsz	cn,1		
		goto	Dv6
		return
Dv6		bcf		STATUS,C
		rrf		y3,1	
		rrf		y2,1
		rrf		y1,1	
		rrf		y0,1
		goto	Dv2
	;=============================
;-----------------------------------------------------
;	24rbgoCiZTu[` x=475x564=D'267900'=H'4 16 7C' (475`285)
;		val<24bit> = x<24bit> / y<16bit>; 
;
;	x 24 rbgf[^u܂B
;		ix[2]:x[1]:x[0]) x=475x564=D'267900'=H'4 16 7C'
;
;       y 16ޯްu܂B(475`285)
;              y[1]:y[0];  ő  H'FFFF'łB
;
;	val ɓi[܂B
;                i:val[2]:val[1]:val[0])  ]x[1][0]
;	vZ̉ߒ	Z		(24bit)(24bit)|y(24bit)gp
;       vZ̉ߒval[3]-val[0]Aval[0] ĝŒ`KvłB
;		
;
Div2_xYY		;(475x564)/Nr
		movlw	H'0'
		movwf	x3		;;xx=475x564=D'267900'=H'4 16 7C'
		movlw	H'4'		;movf	x2,0    
		movwf	x2
		movlw   H'16'		;movf	x1,0
		movwf	x1
		movlw	H'7C'		;	movf	x0,0
		movwf	x0

		movf	y1,0		;y=y *256*256
		movwf	y3
		movf	y0,0
		movwf	y2
		clrf	y1
		clrf	y0
		movlw	D'17'			
		movwf	cn
		movlw	D'16'			
		movwf	cs
		clrf	val0
		clrf	val1
		clrf	val2
		clrf	val3

Dv2_1	movf	cs,1
		btfsc	STATUS,Z	;if y=0, can't divided then return
		return	
		btfsc	y3,7	;if y3.7 =0, then y rotate
		goto	Dv2_2
		bcf		STATUS,C
		rlf		y2,1
		rlf		y3,1
		incf	cn,1
		decfsz	cs,1
		goto 	Dv2_1		
				
Dv2_2		;;x>=y ? check

		movf	x3,0
		subwf	y3,0		; W=y3+ (256-x3)
		btfss	STATUS,C	; if y3<x3, then Dv3
		goto	Dv2_3
		btfss	STATUS,Z	; if y3>x3, then Dv4
		goto	Dv2_4

		movf	x2,0
		subwf	y2,0		; W=y2+ (256-x2)
		btfss	STATUS,C	; if y2<x2, then Dv3
		goto	Dv2_3
		btfss	STATUS,Z	; if y2>x2, then Dv4
		goto	Dv2_4

		movf	x1,0		
		subwf	y1,0		; W=y1+ (256-x1)
		btfss	STATUS,C	; if y1<x1, then Dv3
		goto	Dv2_3
		btfss	STATUS,Z	; if y1>x1, then Dv4
		goto	Dv2_4

		movf	x0,0
		subwf	y0,0		; W=y0+ (256-x0)
		btfss	STATUS,C	; if y0<x0, then Dv3
		goto	Dv2_3
		btfss	STATUS,Z	; if y0>x0, then Dv4
		goto	Dv2_4
		goto	Dv2_3

Dv2_3		;x>=y@Ȃ̂ňZ
		call 	sub_xy	;(24bit)(24bit)|y(24bit)
		bsf		STATUS,C	
		goto	Dv2_5

Dv2_4		;x<y Ȃ̂ 
		bcf		STATUS,C	
Dv2_5	rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1	
		decfsz	cn,1		
		goto	Dv2_6
		return
Dv2_6	bcf		STATUS,C
		rrf		y3,1	
		rrf		y2,1
		rrf		y1,1	
		rrf		y0,1
		goto	Dv2_2
;-=========================
      END                       ; directive 'end of program'
